Package com.io7m.waxmill.realize

# Class WXMRealizationInstructions

java.lang.Object
com.io7m.waxmill.realize.WXMRealizationInstructions

All Implemented Interfaces:
  `WXMRealizationInstructionsType`

    public final class WXMRealizationInstructions
    extends java.lang.Object
    implements WXMRealizationInstructionsType

Immutable implementation of `WXMRealizationInstructionsType`.

Use the builder to create immutable instances: `WXMRealizationInstructions.builder()`.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXMRealizationInstructions.Builder` | Builds instances of type `WXMRealizationInstructions`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static WXMRealizationInstructions.Builder` | `builder()` | Creates a builder for `WXMRealizationInstructions`.
  `static WXMRealizationInstructions` | `copyOf​(WXMRealizationInstructionsType instance)` | Creates an immutable copy of a `WXMRealizationInstructionsType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXMRealizationInstructions` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `steps`.
  `java.util.List<WXMRealizationStepType>` | `steps()` |
  `java.lang.String` | `toString()` | Prints the immutable value `WXMRealizationInstructions` with attribute values.
  `WXMRealizationInstructions` | `withSteps​(WXMRealizationStepType... elements)` | Copy the current immutable object with elements that replace the content of `steps`.
  `WXMRealizationInstructions` | `withSteps​(java.lang.Iterable<? extends WXMRealizationStepType> elements)` | Copy the current immutable object with elements that replace the content of `steps`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.waxmill.realize.WXMRealizationInstructionsType

  `execute`

- ## Method Details

  - ### steps

    public java.util.List<WXMRealizationStepType> steps()
    Specified by:
      `steps` in interface `WXMRealizationInstructionsType`
    Returns:
      The value of the `steps` attribute

  - ### withSteps

    public final WXMRealizationInstructions withSteps​(WXMRealizationStepType... elements)
    Copy the current immutable object with elements that replace the content of `steps`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withSteps

    public final WXMRealizationInstructions withSteps​(java.lang.Iterable<? extends WXMRealizationStepType> elements)
    Copy the current immutable object with elements that replace the content of `steps`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of steps elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXMRealizationInstructions` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `steps`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXMRealizationInstructions` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static WXMRealizationInstructions copyOf​(WXMRealizationInstructionsType instance)
    Creates an immutable copy of a `WXMRealizationInstructionsType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXMRealizationInstructions instance

  - ### builder

    public static WXMRealizationInstructions.Builder builder()
    Creates a builder for `WXMRealizationInstructions`.

         WXMRealizationInstructions.builder()
            .addSteps|addAllSteps(com.io7m.waxmill.realize.WXMRealizationStepType) // steps elements
            .build();

    Returns:
      A new WXMRealizationInstructions builder